EDIT - bug #8027

Hibernate fails to obtain transaction-synchronized Session for thread and brings taxeditor in
unrecoverable state

01/28/2019 12:58 PM - Andreas Kohlbecker

Status: New Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.46

Severity: major Found in Version:

Description

Walter reported:
Hallo,

hatte vorhin schon einmal kurzzeitig so ein Aus, jetzt wohl dauerhaft (seit Minuten). Internet 1auft. Mist, mitten beim Arbeiten.
Nach Neustart lauft's aber wieder — nur Eingabe weg

3% Remote Access Error O x

I.-"'_"‘-.I Maybe the server is currently not available, If the problem persists please contact the
‘S’ server admin with the error trace below,

Z org.springframework.remoting.RemotefccessException: Could not access HTTP
invoker remote service at L
[http://api.cybertaxonomy.org:20/salvador/remoting/reference service]; nested
exception is java.lang.MullPointerException

Copy Error Details > =

This was caused by Hibernate failing to obtain a transaction-synchronized Session for the current thread

[salvador] 2019-01-26 14:37:48,341 ERROR [qgtpl012570586-3113] [eu.etaxonomy.cdm.persistence.dao.hi
bernate.common.DaoBase] - Opening new session in turn of a HibernateException
org.hibernate.HibernateException: Could not obtain transaction-synchronized Session for current th
read

at org.springframework.orm.hibernate5.SpringSessionContext.currentSession (SpringSessionCon
text.java:132)

at org.hibernate.internal.SessionFactoryImpl.getCurrentSession (SessionFactoryImpl.java:697

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.DaoBase.getSession (DaoBase.java:59)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.getSession (CdmEntity
DaoBase. java:267)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.findByUuid (CdmEntity
DaoBase. java:414)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.findByUuid (CdmEntity
DaoBase.java:410)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.findByUuid (Version
ableDaoBase. java:67)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.findByUuid (Version
ableDaoBase. java:36)

at eu.etaxonomy.cdm.api.service.ServiceBase.find(ServiceBase. java:148)

at eu.etaxonomy.cdm.api.service.VersionableServiceBase.isDeletable (VersionableServiceBase.
java:81)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)
at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:3
02)
at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy. java:202

at com.sun.proxy.S$SProxyl828.isDeletable (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:3
02)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Reflective
MethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation. java:157)

at org.springframework.remoting.support.RemoteInvocationTracelInterceptor.invoke (RemotelInvo
cationTracelnterceptor. java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy. java:208

at com.sun.proxy.S$SProxy2203.isDeletable (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemoteInvocation. java:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (DefaultRemo
teInvocationExecutor. java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (Remotelnvocat
ionBasedExporter.java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResul
t (RemoteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (Httpl
nvokerServiceExporter. java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandler
Adapter.java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet. java:959

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:9
69)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:871)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet.java:845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (Filt
erSecurityInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Fi
lterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTr
anslationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManage
mentFilter. java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doF
ilter (SecurityContextHolderAwareRequestFilter.java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestC
acheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterI
nternal (BasicAuthenticationFilter.java:213)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilt
er.java:120)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWrite
rFilter.java:64)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFilter (Secu
rityContextPersistenceFilter.java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter
.doFilterInternal (WebAsyncManagerIntegrationFilter. java:53)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainProxy. jav
a:213)

at org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy.java:176)

at org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterPro
Xy.java:346)

at org.springframework.web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy. jav
a:262)

at org.eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1652)

at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodi
ngFilter.java:121)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.eclipse.jetty.servlet.ServletHandler$SCachedChain.doFilter (ServletHandler. java:1652)

at org.eclipse.jetty.servlet.ServletHandler.doHandle (ServletHandler. java:585)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:143)

at org.eclipse.jetty.security.SecurityHandler.handle (SecurityHandler. java:577)

at org.eclipse.jetty.server.session.SessionHandler.doHandle (SessionHandler. java:223)

at org.eclipse.jetty.server.handler.ContextHandler.doHandle (ContextHandler. java:1127)

at org.eclipse.jetty.servlet.ServletHandler.doScope (ServletHandler. java:515)

at org.eclipse.jetty.server.session.SessionHandler.doScope (SessionHandler. java:185)

at org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler.java:1061)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:141)

at org.eclipse.jetty.server.handler.ContextHandlerCollection.handle (ContextHandlerCollecti
on.java:215)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)

at org.eclipse.jetty.server.Server.handle (Server. java:497)

at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:310)

at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)

at org.eclipse.jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)

at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)

at java.lang.Thread.run (Thread. java:745)

History

#1 - 01/28/2019 01:00 PM - Andreas Kohlbecker
Can the TaxEditor be made more resilient against these types of problems by catching this exception and trying to recover from this failure?

#2 - 01/29/2019 01:59 PM - Andreas Miiller

- Assignee changed from Andreas Miiller to Katja Luther

Personally | don't think it is a TaxEditor problem. It rather looks like the server had the problem and could not recover. But not sure as | do not have
more information. Did the server restart afterwards?

Does anybody know if this happened before? To me it is new. Is it possible to search the log files for previous errors of this type.
#3 - 01/29/2019 02:18 PM - Andreas Kohlbecker
Andreas Muller wrote:

Personally | don't think it is a TaxEditor problem. It rather looks like the server had the problem and could not recover. But not sure as | do not
have more information. Did the server restart afterwards?

Does anybody know if this happen before? To me it is new. Is it possible to search the log files for previous errors of this type.

| found 44 occurrences like this in the edit-production log file since 2018-10-26, please find the report attached as
edit-prod_transaction-synchronized-2018-10-26.txt

The server did not restart after this incidence. | also don't think that this is a taxeditor problem, it is most probably a problem with hibernate, maybe

with the conversation holder. But the taxeditor could be made resilient against this type of problems to avoid the need to restart it.

#4 - 01/29/2019 02:24 PM - Andreas Kohlbecker
- File edit-prod_transaction-synchronized-2018-10-26.txt added
- File 2019-01-26-out-clean.log added

| also attached the cleaned log from edit-production for the 2019-01-26 where | found this issue the first time: 2019-01-26-out-clean.log
#5 - 01/29/2019 04:57 PM - Andreas Miiller
Andreas Kohlbecker wrote:
| also don't think that this is a taxeditor problem, it is most probably a problem with hibernate, maybe with the conversation holder. But the

taxeditor could be made resilient against this type of problems to avoid the need to restart it.

| still do not fully understand. Does it mean that restarting the TaxEditor solves the problem for the client? If yes | wonder how this can be. The
TaxEditor only should have short sessions. So no matter if you restart the Editor in between calling the methods. But probably | miss something here.

#6 - 01/29/2019 04:59 PM - Andreas Miiller

Maybe we should split the ticket into 1. avoid the hibernate issue and 2. make the client and/or server resilient to such issues.

#7 - 01/29/2019 05:00 PM - Andreas Miiller
- Target version changed from Unassigned CDM tickets to Release 5.6

- Severity changed from normal to major

As this happened 44 times since October | consider it to be a severe issue. Do you agree to take it to the next version as issue?

#8 - 01/29/2019 06:05 PM - Andreas Kohlbecker
Andreas Muller wrote:
Andreas Kohlbecker wrote:
| also don't think that this is a taxeditor problem, it is most probably a problem with hibernate, maybe with the conversation holder. But the

taxeditor could be made resilient against this type of problems to avoid the need to restart it.

| still do not fully understand. Does it mean that restarting the TaxEditor solves the problem for the client? If yes | wonder how this can be. The
TaxEditor only should have short sessions. So no matter if you restart the Editor in between calling the methods. But probably | miss something
here.

This is how | understood Walter in his email: "Nach Neustart Iduft’s aber wieder — nur Eingabe weg" However, | did not try to verify this assumption.
https://dev.e-taxonomy.eu/redmine/attachments/1494
https://dev.e-taxonomy.eu/redmine/attachments/1495

#9 - 02/22/2019 09:54 AM - Katja Luther
- Priority changed from New to Highest

- Target version changed from Release 5.6 to Release 5.7

#10 - 05/03/2019 04:52 PM - Katja Luther

- Target version changed from Release 5.7 to Release 5.8

#11 - 07/19/2019 03:22 PM - Andreas Miiller

- Target version changed from Release 5.8 to Release 5.10

#12 - 09/18/2019 05:02 PM - Katja Luther

- Target version changed from Release 5.10 to Release 5.11

#13 - 11/04/2019 12:40 PM - Andreas Miiller

- Target version changed from Release 5.11 to Release 5.12

#14 - 01/16/2020 12:59 PM - Katja Luther

- Target version changed from Release 5.12 to Release 5.13

#15 - 03/09/2020 04:26 PM - Andreas Miiller

- Target version changed from Release 5.13 to Release 5.14

#16 - 04/01/2020 09:02 AM - Katja Luther

- Target version changed from Release 5.14 to Release 5.15

#17 - 06/23/2020 01:51 PM - Andreas Miiller

- Target version changed from Release 5.15 to Release 5.18

#18 - 12/04/2020 09:09 AM - Katja Luther

- Target version changed from Release 5.18 to Release 5.19

#19 - 01/27/2021 04:13 PM - Andreas Miiller

- Target version changed from Release 5.19 to Release 5.21

#20 - 03/10/2021 02:51 PM - Andreas Miiller

- Target version changed from Release 5.21 to Release 5.22

#21 - 04/19/2021 05:41 PM - Katja Luther

- Target version changed from Release 5.22 to Release 5.46
